<?php
/*
Plugin Name: RedaWeb
Plugin URI: https://redaweb.com.br/
Description: Publique seus textos diretamente do seu painel RedaWeb.
Version: 1.0
Author: Agência Redaweb
Author URI: https://redaweb.com.br/
License: GPLv2 or later
Text Domain: redaweb
*/


$option_name = 'chave_unica_redaweb' ;
$chave_unica = md5( microtime().rand().time().$_SERVER['SERVER_NAME'] );

if ( !get_option( $option_name ) ) {
    $deprecated = null;
    $autoload = 'no';
    add_option( $option_name, $chave_unica, $deprecated, $autoload );
}

add_action('admin_init', 'redawebField');  

function redawebField() {  
    add_settings_section(  
        'chave_unica_redaweb', 
        'RedaWeb', 
        'redawebField_callback', 
        'general' 
    );

    add_settings_field( 
        'chave_unica_redaweb', 
        'Chave Única', 
        'redaweb_textbox', 
        'general', 
        'chave_unica_redaweb', 
        array( 
            'chave_unica_redaweb' 
        )  
    ); 

    register_setting('general','chave_unica_redaweb', 'esc_attr');
}

function redawebField_callback() { 
    echo '<p>Essa é sua chave única. Copie-a e cole em seu painel RedaWeb.</p>';  
}

function redaweb_textbox($args) {  
    $option = get_option($args[0]);
    echo '<input readonly="" type="text" id="'. $args[0] .'" style="width:50%;" name="'. $args[0] .'" value="' . $option . '" />';
}

/* -------------------------------------------- */

function create_routes( $router ) {
    $router->add_route('api-redaweb', array(
        'access_callback' => true,
        'page_callback' => 'redaweb_api',
        'path' => '^api-redaweb/(.*?)/(.*?)$',
		'query_vars' => array(
			'key' => 1,
			'func' => 2,
		),
		'page_arguments' => array('key', 'func'),
    ));

}
add_action( 'wp_router_generate_routes', 'create_routes' );


function redaweb_api( $a,$b ){
	header("Content-Type: application/json; charset=utf-8");
	$chave_unica = get_option( "chave_unica_redaweb" );

	$json = array();

	if($chave_unica==$a) {

		if($b=="post") {
			$post_title		= $_POST['post_title'];
			$post_content 	= $_POST['post_content'];
			$post_type 		= $_POST['post_type'];
			$post_status 	= $_POST['post_status'];
			$post_author 	= $_POST['post_author'];
			$comment_status = $_POST['comment_status'];
			$post_category	= $_POST['post_category'];

			if(!$post_title) {
				$json['message'] 	= "Post title is empty";
				$json['status'] 	= "error";
			}

			if(!$post_content) {
				$json['message'] 	= "Post content is empty";
				$json['status'] 	= "error";
			}

			if(!$post_type) $post_type = "post";
			if(!$post_status) $post_status = "draft";
			if(!$post_author) $post_author = 1;
			if(!$comment_status) $comment_status = "closed";

			if($json['status']!="error") {
				$post_id = wp_insert_post(
					array(
						'comment_status'	=>	$comment_status,
						'ping_status'		=>	'closed',
						'post_author'		=>	$post_author,
						'post_title'		=>	$post_title,
						'post_content'		=> 	$post_content,
						'post_status'		=>	$post_status,
						'post_type'			=>	$post_type,
						'post_category' 	=> 	array($post_category)
					)
				);
				$json['message'] 	= "Success!";
				$json['post_id']	= $post_id;
				$json['status'] 	= "okey";
			}
		}

		if($b=="cat"){

			$args = array(
				'orderby'   => 'name',
        		'order'     => 'ASC',
				'hide_empty'=> 0,
			);
			$categories = get_categories($args);
			

			$json['message'] 	= "Success!";
			$json['result']		= $categories;
			$json['status'] 	= "okey";
		}

	} else {
		$json['message'] 	= "Invalid Key";
		$json['status'] 	= "error";
	}
	echo json_encode($json); die();
}
if ( !function_exists('WP_Router_load') ) {
	function WP_Router_load() {
		// load the base class
		require_once 'WP_Router_Utility.class.php';

		if ( WP_Router_Utility::prerequisites_met(phpversion(), get_bloginfo('version')) ) {
			// we can continue. Load all supporting files and hook into wordpress
			require_once 'WP_Router.class.php';
			require_once 'WP_Route.class.php';
			require_once 'WP_Router_Page.class.php';
			add_action('init', array('WP_Router_Utility', 'init'), -100, 0);
			add_action(WP_Router_Utility::PLUGIN_INIT_HOOK, array('WP_Router_Page', 'init'), 0, 0);
			add_action(WP_Router_Utility::PLUGIN_INIT_HOOK, array('WP_Router', 'init'), 1, 0);


		} else {
			// let the user know prerequisites weren't met
			add_action('admin_head', array('WP_Router_Utility', 'failed_to_load_notices'), 0, 0);
		}
	}
	// Fire it up!
	WP_Router_load();
}
